from jigu.api import BaseAPI
from jigu.core import AccAddress, Coins
from jigu.util.validation import validate_acc_address


class BankAPI(BaseAPI):
    def get_balances(self, address: AccAddress) -> Coins:
        validate_acc_address(address)
        balances = self._api_get(f"/bank/balances/{address}")
        return Coins.deserialize(balances)
