import jigu.core.sdk.address
from jigu.core.sdk.address import AccAddress, ValAddress

AccPubKey = str
ValPubKey = str
ValConsPubKey = str

BlocksPerMinute = 10
BlocksPerHour = BlocksPerMinute * 60
BlocksPerDay = BlocksPerHour * 24
BlocksPerWeek = BlocksPerDay * 7
BlocksPerMonth = BlocksPerDay * 30
BlocksPerYear = BlocksPerDay * 365
BlocksPerEpoch = BlocksPerWeek

from .sdk import Coin, Coins, Dec, Timestamp
from .proposal import Proposal, Content
from .msg import StdMsg

from .bank import Input, Output
from .oracle import ExchangeRatePrevote, ExchangeRateVote
from .staking import (
    CommissionRates,
    Delegation,
    Redelegation,
    RedelegationEntry,
    UnbondingDelegation,
    UnbondingEntry,
    Validator,
    Description,
    Commission,
    CommissionRates,
)
from .block import Block
from .treasury import PolicyConstraints
from .auth.account import Account, LazyGradedVestingAccount, PublicKey
from .auth.transaction import StdFee, StdSignature, StdSignMsg, StdTx, TxInfo

# Descriptive aliases

UnsignedTx = StdSignMsg
SignedTx = StdTx
Signature = StdSignature
Fee = StdFee
