from bech32 import bech32_decode, bech32_encode
from jigu.util.validation import validate_val_address, validate_acc_address


class AccAddress(str):
    def __new__(cls, arg):
        validate_acc_address(arg)
        return str.__new__(cls, arg)

    @property
    def val_address(self):
        decoded = bech32_decode(self.address)
        return ValAddress(bech32_encode("terravaloper", decoded[1]))


class ValAddress(str):
    def __new__(cls, arg):
        validate_val_address(arg)
        return str.__new__(cls, arg)

    @property
    def acc_address(self):
        decoded = bech32_decode(self)
        return AccAddress(bech32_encode("terra", decoded[1]))
