from __future__ import annotations

import jigu.query
import jigu.terra
from jigu.core import AccAddress, Proposal


class ProposalQuery(object):
    def __init__(self, terra: jigu.terra.Terra, proposal_id: int):
        self.terra = terra
        self.proposal_id = proposal_id

    def __repr__(self):
        return f"ProposalQuery({self.proposal_id!r}) -> {self.terra}"

    def info(self) -> Proposal:
        return self.terra.gov.proposals(id=self.proposal_id)

    def proposer(self) -> AccAddress:
        return self.terra.gov.get_proposal_proposer(id=self.proposal_id)

    def deposits(self):
        return self.terra.gov.get_proposal_deposits(id=self.proposal_id)

    def votes(self):
        return self.terra.gov.get_proposal_votes(id=self.proposal_id)

    def tally(self):
        return self.terra.gov.get_proposal_tally(id=self.proposal_id)
